<template>
  <div class="login">
    <q-card class="q-pa-md absolute right-40 top-64 w-80">
      <q-form
          @submit="onSubmit"
          @reset="onReset"
          class="q-gutter-md mb-0"
      >
        <q-input
            filled
            v-model="username"
            label="Логин"
            hint="Ваш уникальный логин"
            lazy-rules
            :rules="[ val => val && val.length > 0 || 'Введите логин']"
        />

        <q-input
            filled
            v-model="password"
            label="Пароль"
            lazy-rules
            :rules="[val => val !== null && val !== '' || 'Введите пароль']"
            :type="isPwd ? 'password' : 'text'"
            toggle
        >
          <template v-slot:append>
            <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
            />
          </template>
        </q-input>

        <p v-if="!isBlackBlockUser" :class="{'opacity-1':valid, 'opacity-0':!valid}" class="text-red italic text-center">Неправильный логин или пароль</p>
        <p v-if="isBlackBlockUser" :class="{'opacity-1':isBlackBlockUser, 'opacity-0':!isBlackBlockUser}" class="text-red italic text-center">Пользователь заблокирован</p>
        <div class="float-right">
          <q-btn label="Очистить" type="reset" color="primary" flat class="q-ml-sm" />
          <q-btn label="Войти" type="submit" color="primary"/>
        </div>
      </q-form>
    </q-card>

    <q-img width="200" class="absolute right-52 bottom-52" src="../assets/img/auth/logo.png"/>
  </div>
</template>

<script>
import {ref, watch} from "vue"
import api from "../API/api";
import {useStore} from "vuex";
import router from "../router/";
export default {
  name: "Auth",
  setup () {
    const store = useStore()

    const username = ref(null)
    const password = ref(null)
    const valid = ref(false)
    const isBlackBlockUser = ref(false)
    watch(username, () => valid.value = false)
    watch(password, () => valid.value = false)

    return {
      username,
      password,
      valid,
      isBlackBlockUser,
      isPwd: ref(true),

      async onSubmit() {
        await api.login({username: username.value, password: password.value})
        .then(res => {
            if (!res.data.user.status) return isBlackBlockUser.value = true
            else {
              store.state.user = res.data.user
              store.state.token = res.data.token
              localStorage.setItem('token', res.data.token)
              localStorage.setItem('user', JSON.stringify(res.data.user))
              router.replace('/')
            }
        })
        .catch(() => valid.value = true)
      },

      onReset() {
        username.value = null
        password.value = null
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.login {
  width: 100vw;
  height: 100vh;
  background: url('../assets/img/auth/bg_1.jpg');
  background-position: center;
  background-size: cover;
}
</style>
